package ui.model;

import classes.CpsEdge;
import classes.HolonObject;
import ui.model.DecoratedCable.DecoratedCableState;

/**
 * Intermediate to calculate/simulate the burning of Cables.
 * When all burning is done the Cable will be represented as a DecoratedCable.
 * @see DecoratedCable
 */
public class CableWithState {
	public enum CableState{
		Undefined, Working, Burned
	}
	private CableState state;
	private CpsEdge model;
	public CableWithState(CpsEdge model,CableState state)
	{
		this.model = model;
		this.state = state;
	}
	public CableState getState() {
		return state;
	}
	public void setState(CableState state) {
		this.state = state;
	}
	public CpsEdge getModel() {
		return model;
	}
	//ugly
	public float getEnergyFromConnetedAtTimestep(int iteration) {
		float energy = 0.0f;
		if(model.getA() instanceof HolonObject && ((HolonObject) model.getA()).getEnergyAtTimeStep(iteration) > 0) energy += ((HolonObject) model.getA()).getEnergyAtTimeStep(iteration);
		if(model.getB() instanceof HolonObject && ((HolonObject) model.getB()).getEnergyAtTimeStep(iteration) > 0) energy += ((HolonObject) model.getB()).getEnergyAtTimeStep(iteration);
		return energy;
	}
	
	//to be swapped with on CableState system 
	public static DecoratedCableState convertCableStateToDecoratedCableState(CableState toConvert) {
		switch(toConvert) {
		case Burned:
			return DecoratedCableState.Burned;
		case Working:
			return DecoratedCableState.Working;
		case Undefined:
			return DecoratedCableState.Burned;
		default:
			return DecoratedCableState.Burned;
		
		}
	}
}
